# Before `make install' is performed this script should be runnable
# with `make test'. After `make install' it should work as `perl
# DOMException.t'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..5\n"; }
END {print "not ok 1\n" unless $loaded;}
use Carp;

# use blib;
use XML::Xerces;
use Config;

use lib 't';
use TestUtils qw(result);
use vars qw($i $loaded $error $messageNS $messageNR);
use strict;

$loaded = 1;
$i = 1;
result($loaded);

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

# test that we get an DOM_DOMException trying to reuse a DocType
$error = 0;
my $handler = XML::Xerces::PerlExceptionHandler::getInstance();
$handler->setSAXNotRecognizedExceptionHandler(sub{
  my $exception = shift;
  $messageNR = $exception->getMessage();
  $error = 1;
  die();
});

$handler->setSAXNotSupportedExceptionHandler(sub{
  my $exception = shift;
  $messageNS = $exception->getMessage();
  $error = 1;
  die();
});


my $parser = XML::Xerces::XMLReaderFactory::createXMLReader();


eval {
  $parser->setFeature("http://xml.org/sax/features/foospaces", 0);
};

result($@ && $error);

# reset the error counter
$error = 0;
$messageNS = '';
$messageNR = '';

eval {
  $parser->getFeature('http://xml.org/sax/features/foospaces');
};

result($@ && $error);

# reset the error counter
$error = 0;

eval {
  $parser->getProperty('http://xml.org/sax/features/foospaces');
};

result($@ && $error);

# reset the error counter
$error = 0;

eval {
  $parser->setProperty('http://xml.org/sax/features/foospaces', $parser);
};

result($@ && $error);

# print STDERR "MessageNS = $messageNS\n";
# print STDERR "MessageNR = $messageNR\n";
# print STDERR "Error = $error\n";
# print STDERR "Eval = $@\n";
